﻿package ld16.gameobjects
{
    import flash.display.Bitmap;
    import flash.display.Sprite;
    import stego.constants.Colors;
    import stego.core.GameObject;
    import stego.PlatformerCharacter;
    import stego.Util;
    import stego.util.MathUtil;

    /**
     * ...
     * @author Mike Meyer
     */
    public class Destructable extends GameObject
    {
        [Embed(source='../assets/spikyblock.png')]
        private static const SpikyGraphic:Class;

        private var theta:Number;
        private var rate:Number;
        private var graphic:Bitmap;
        private var offset:Number = 4;
        private var size:Number = 28;

        public override function Init():void
        {
            super.Init();
            theta = Math.random() * 2 * Math.PI;
            rate = Util.RandomOneOf([ -4, -2, -1.618, 1.618, 2, 4]) * Math.PI;
            offset = MathUtil.Lerp(1, 4, Math.random());
            AffectedByGravity = false;
            PhysicsEnabled = false;
            CreateGraphics();
        }

        protected function CreateGraphics():void
        {
            if (null == graphic)
            {
                graphic = new SpikyGraphic();
                addChild(graphic);
            }
        }

        public override function Update(elapsedTime:Number):void
        {
            super.Update(elapsedTime);

            theta = MathUtil.Wrap(theta + elapsedTime * rate, 0, 2 * Math.PI);
            graphic.x = offset * Math.cos(theta) - 0.5 * graphic.width;
            graphic.y = offset * Math.sin(theta) - 0.5 * graphic.height;
        }
    }

}
