﻿package ld16.gameobjects
{
    import stego.PlatformerCharacter;
    import stego.util.spriteanim.SpriteAnimUtil;

    /**
     * ...
     * @author Mike Meyer
     */
    public class Prize extends PlatformerCharacter
    {
        [Embed(source='../assets/prize.png')]
        private static const PRIZE_0:Class;
        [Embed(source='../assets/prize_shine0.png')]
        private static const PRIZE_1:Class;
        [Embed(source='../assets/prize_shine1.png')]
        private static const PRIZE_2:Class;
        [Embed(source='../assets/prize_shine2.png')]
        private static const PRIZE_3:Class;
        private static const PRIZE_FRAMES:Array = [PRIZE_0, PRIZE_0, PRIZE_0, PRIZE_0, PRIZE_0, PRIZE_1, PRIZE_2, PRIZE_3];

        private var mAnimUtil:SpriteAnimUtil;

        public override function Init():void
        {
            super.Init();
            CreateGraphics();
            Restart();
        }

        protected function CreateGraphics():void
        {
            if (null == mAnimUtil)
            {
                mAnimUtil = new SpriteAnimUtil(this);
                mAnimUtil.AddAnimation("shine", PRIZE_FRAMES, 16.0);
                mAnimUtil.curAnim = "shine";
            }
        }
        /**
         * per-frame update
         * @param   elapsedTime - time since the last frame
         */
        public override function Update(elapsedTime:Number):void
        {
            super.Update(elapsedTime);
            mAnimUtil.Update(elapsedTime);
        }
    }

}
