﻿package ld16.gamestate
{
    import flash.events.Event;
    import ld16.GameContent;
    import stego.constants.Colors;
    import stego.core.GameInterface;
    import stego.core.GameState;
    import stego.Settings;
    import stego.util.GuiBuilder;

    /**
     * ...
     * @author Mike Meyer
     */
    public class Title extends GameState
    {
        public override function Begin(game:GameInterface):void
        {
            super.Begin(game);

            var builder:GuiBuilder = new GuiBuilder(game.StageRect, game.Layers.UiLayer);
            builder.Font = GameContent.TuffyBoldFont;
            builder.FontSize = 64;
            builder.FontColor = Colors.WHITE_ENOUGH;
            builder.HighlightColor = Colors.WHITE;
            builder.AddTextCentered("Gallery", 0.5, 0.4);
            builder.Font = Settings.Font;
            builder.FontSize = 32;
            builder.AddPulsingButtonCentered("click to play", BeginPlaying, 0.5, 0.7);
        }

        private function BeginPlaying(event:Event):void
        {
            Game.ChangeGameState(new Overworld());
        }

        public override function End():void
        {
            Game.Layers.RemoveAll();
            super.End();
        }
    }

}
