﻿package ld16.subgame
{
    import ld16.G;
    import ld16.gameobjects.Dude;
    import ld16.gameobjects.Platform;
    import stego.core.GameInterface;
    import stego.core.GameState;

    /**
     * ...
     * @author Mike Meyer
     */
    public class TestGameState extends GameState
    {
        private var player:Dude;

        public override function Begin(game:GameInterface):void
        {
            super.Begin(game);

            BuildScene();
        }

        private function BuildScene():void
        {
            // walls to keep him on screen
            var thickness:Number = 64;

            // floor
            PlacePlatform(-thickness, G.SubGameRect.height, G.SubGameRect.width + thickness, thickness);
            // right
            PlacePlatform(G.SubGameRect.width, 0, thickness, G.SubGameRect.height + thickness);
            // top
            PlacePlatform(0, -thickness, G.SubGameRect.width + thickness, thickness);
            // left
            PlacePlatform( -thickness, -thickness, thickness, G.SubGameRect.height + thickness);

            player = Game.Layers.PlayerLayer.Add(Dude) as Dude;
            player.inputUtil = Game.inputUtil;
            player.x = 0.5 * G.SubGameRect.width;
            player.y = 0.5 * G.SubGameRect.height;
        }

        public function PlacePlatform(x:Number, y:Number, width:Number, height:Number):void
        {
            var platform:Platform = Game.Layers.PlatformLayer.Add(Platform) as Platform;
            platform.Place(x, y, width, height);
        }

        public override function End():void
        {
            Game.Layers.RemoveAll();
            super.End();
        }
    }

}
