﻿package ld16.subgame.gamestate
{
    import flash.events.Event;
    import ld16.G;
    import ld16.gameobjects.Prize;
    import ld16.gameobjects.Spiky;
    import ld16.gamestate.Overworld;
    import stego.core.GameInterface;
    import stego.script.step.Animate;
    import stego.script.step.AnimateTo;
    import stego.script.step.Loop;
    import stego.script.step.WaitTime;
    import stego.Util;

    /**
     * ...
     * @author Mike Meyer
     */
    public class Avoid extends SuperEasy
    {
        public override function Begin(game:GameInterface):void
        {
            super.Begin(game);
        }

        protected override function CreateSpikies():void
        {
            super.CreateSpikies();
            var spiky:Spiky = Game.Layers.EnemyLayer.Add(Spiky) as Spiky;
            spiky.PhysicsEnabled = false;
            spiky.AffectedByGravity = false;
            spiky.x = G.SubGameRect.width - spiky.width;
            spiky.y = G.SubGameRect.height - spiky.height;

            spiky.scheduler.RunScript( new Loop(1, [ new WaitTime(1.8),
                                                     new Loop( -1, [ new Animate(spiky, { x:spiky.x }, { x:0 }, 1.0),
                                                                     new Animate(spiky, {x:0}, {x:spiky.x}, 1.0 ) ] ) ] ) );
        }

        protected override function CreatePrize():void
        {
            var prize:Prize = Game.Layers.ItemLayer.Add(Prize) as Prize;
            prize.x = G.SubGameRect.width - (0.5 * prize.width);
            prize.y = G.SubGameRect.height - prize.height;
            prize.dy = -800;
        }

        protected override function CreatePlatforms():void
        {
            super.CreatePlatforms();

            PlacePlatform(
                0,
                0,
                0.3 * G.SubGameRect.width,
                G.SubGameRect.height - 80);
            PlacePlatform(
                0.3 * G.SubGameRect.width,
                0,
                0.4 * G.SubGameRect.width,
                G.SubGameRect.height - 160);
            PlacePlatform(
                0.7 * G.SubGameRect.width,
                0,
                0.3 * G.SubGameRect.width,
                G.SubGameRect.height - 80);
        }

        protected override function GameOver():void
        {
            super.GameOver();
            for each (var spiky:Spiky in Game.Layers.EnemyLayer.Objects)
            {
                spiky.scheduler.Shutdown();
            }
        }
    }

}
