﻿package ld16.subgame.gamestate
{
    import ld16.G;
    import ld16.gameobjects.Dude;
    import ld16.gameobjects.LessEasyDude;
    import ld16.gameobjects.Prize;
    import stego.script.Step;
    import stego.script.step.Animate;
    import stego.script.step.Loop;
    import stego.script.step.RunFunc;
    import stego.script.step.WaitTime;

    /**
     * ...
     * @author Mike Meyer
     */
    public class LessEasy extends SuperEasy
    {
        protected override function CreatePlayer():void
        {
            player = Game.Layers.PlayerLayer.Add(LessEasyDude) as Dude;
            player.inputUtil = Game.inputUtil;
            player.x = 0.2 * G.SubGameRect.width;
            player.y = 0.8 * G.SubGameRect.height;
        }

        protected override function CreatePlatforms():void
        {
        }

        protected override function CreatePrize():void
        {
            AddPrize1();
            AddPrize2();
            AddPrize3();
        }

        private function AddPrize3():void
        {
            var prize:Prize = AddPrize();
            var startPos:Object = {x:0.8 * G.SubGameRect.width, y:G.SubGameRect.height - prize.height};
            var d:Object = { x:0.5 * G.SubGameRect.width, y:0.5*prize.height, scaleX:1.0, scaleY:1.0 };
            var e:Object = { x:0.5 * G.SubGameRect.width, y:G.SubGameRect.width, scaleX:30.0, scaleY:30.0 };
            prize.scheduler.RunScript(
                new Loop( 1, [
                    new WaitTime(0.5),
                    new Animate(prize,
                        startPos,
                        d,
                        0.5 ),
                    new WaitTime(4.0),
                    new RunFunc(function():void {
                        var lep:LessEasyDude = player as LessEasyDude;
                        lep.autoJumpOn = false; } ),
                    new Animate(prize,
                        d,
                        e,
                        5.0 ) ] ) );
        }

        private function AddPrize2():void
        {
            var prize:Prize = AddPrize();
            var startPos:Object = {x:0.8 * G.SubGameRect.width, y:G.SubGameRect.height - prize.height};
            var b:Object = { x:G.SubGameRect.width - prize.width, y:0.5*prize.height };
            var c:Object = { x:0.4 * G.SubGameRect.width, y:0.5*G.SubGameRect.height };
            prize.scheduler.RunScript(
                new Loop( 1, [
                    new WaitTime(1.25),
                    new RunFunc(function():void {} ),
                    new Loop( -1, [
                        new Animate(prize,
                            startPos,
                            b,
                            0.25 ),
                        new WaitTime(0.5),
                        new Animate(prize,
                            b,
                            c,
                            0.25 ),
                        new WaitTime(0.5),
                        new Animate(prize,
                            c,
                            startPos,
                            0.25 ),
                        new WaitTime(0.5) ] ) ] ) );
        }

        private function AddPrize1():void
        {
            var prize:Prize = AddPrize();
            var startPos:Object = {x:0.8 * G.SubGameRect.width, y:G.SubGameRect.height - prize.height};
            prize.scheduler.RunScript(
                new Loop( 1, [
                    new WaitTime(1.0),
                    new Loop( -1, [
                        new Animate(prize,
                            startPos,
                            {x:prize.width },
                            1.0 ),
                        new Animate(prize,
                            {x:prize.width },
                            startPos,
                            1.0 ) ] ) ] ) );
        }

        private function AddPrize():Prize
        {
            var prize:Prize = Game.Layers.ItemLayer.Add(Prize) as Prize;
            prize.x = 0.8 * G.SubGameRect.width;
            prize.y = G.SubGameRect.height - prize.height;
            prize.AffectedByGravity = false;
            prize.PhysicsEnabled = false;
            return prize;
        }
    }

}
