package stego.screen
{
    import flash.display.Sprite;
    import flash.events.Event;
    import stego.Settings;
    import stego.widget.TextField;
    public class Pause extends Sprite
    {
        protected var mScreenColor:Number;
        protected var mFontColor:Number;
        protected var mAlpha:Number;
        protected var mFont:String;
        protected var mStageWidth:Number;
        protected var mStageHeight:Number;

        function Pause( stageWidth:Number,
                        stageHeight:Number,
                        screenColor:Number = -1,
                        alpha:Number = -1,
                        fontColor:Number = -1,
                        font:String = null)
        {
            super();

            mStageWidth = stageWidth;
            mStageHeight = stageHeight;

            mScreenColor = screenColor;
            if (-1 == mScreenColor) { mScreenColor = Settings.PauseScreenColor; }

            mFontColor = fontColor;
            if (-1 == mFontColor) { mFontColor = Settings.PauseScreenFontColor; }

            mAlpha = alpha;
            if ( -1 == mAlpha) { mAlpha = Settings.PauseScreenAlpha; }

            mFont = font;
            if (null == mFont) { mFont = Settings.PauseScreenFont; }

            if (stage)
            {
                Init();
            }
            else
            {
                addEventListener(Event.ADDED_TO_STAGE, Init);
            }
        }

        private function Init(e:Event = null):void
        {
            var w:Number = mStageWidth;
            var h:Number = mStageHeight;

            this.graphics.beginFill( mScreenColor );
            // making it extra big to avoid camera shake artifacts.
            // for the future, some things should be unscrollable/unshakeable
            this.graphics.drawRect( 0, 0, w, h )
            this.graphics.endFill();
            this.alpha = mAlpha;
            this.visible = false;

            var pauseLabel:TextField = new TextField();
            pauseLabel.SetText("PAUSED");
            pauseLabel.SetFont(mFont);
            pauseLabel.SetFontSize(36);
            pauseLabel.SetFontColor(mFontColor);
            pauseLabel.CenterOn( 0.5 * w, 0.4 * h );
            this.addChild(pauseLabel);

            var clickInstructions:TextField = new TextField();
            clickInstructions.SetText("click to continue");
            clickInstructions.SetFont(mFont);
            clickInstructions.SetFontSize(16);
            clickInstructions.SetFontColor(mFontColor);
            clickInstructions.CenterOn( 0.5 * w, 0.7 *h );
            this.addChild(clickInstructions);
        }
    }
}
