﻿package stego.util.schedule
{
    /**
     * ...
     * @author Mike Meyer
     */
    public class CountdownScheduleItem implements IScheduleItem
    {
        /**
         * function to call after the delay
         * should not require any arguments
         */
        public function get callback():Function { return _callback; }
        private var _callback:Function;

        /**
         * countdown to the next call
         */
        protected var timeLeft:Number;

        /**
         * Will this schedule item ever run again?
         */
        public function get isDone():Boolean { return ((timeLeft <= 0)); }

        /**
         * constructor
         * @param	time - how long to count down from
         * @param	callback - function to call each frame until the timer
         * hits zero.  should take the amount of time left as an arg
         */
        public function CountdownScheduleItem(time:Number, callback:Function)
        {
            timeLeft = time;
            _callback = callback;
        }

        /**
         * tick the countdown, call the callback
         * @param	elapsedTime - how much time has elapsed since the last
         * call to Update
         */
        public function Update(elapsedTime:Number):void
        {
            if (!isDone)
            {
                timeLeft -= elapsedTime;

                if (timeLeft <= 0)
                {
                    callback(0.0);
                    _callback = null;
                }
                else
                {
                    callback(timeLeft);
                }
            }
        }
    }

}
